<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaJs.php
 * Date    :
 * Used for: library for javascript
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class ardeaJs {
    private $initJs=array();
    private $initVbs=array();
    private $scriptJs=array();
    private $scriptVbs=array();
    private $jsPath=array();
    private $regJs=array();
    private $regJsVer=array();
    private $regVb=array();
    private $result="";
    private $jsFunction=array();

    function ardeaJs() {
    }
    function toString() {
        return "Ardea JS";
    }
    function addJsFunction($functionName) {
        $this->jsFunction[$functionName]=new jsFunction($functionName);
        return $this->jsFunction[$functionName];
    }
    function getJsFunction($functionName) {
        if(array_key_exists($functionName,$this->jsFunction)) {
            return $this->jsFunction[$functionName];
        }
    }
    function addInitScript($whatToInit,$isVbs=false) {
        if($isVbs)
            $this->initVbs[count($this->initVbs)]=$whatToInit;
        else
            $this->initJs[count($this->initJs)]=$whatToInit;
    }
    function addScript($whatScript,$isVbs=false) {
        if($isVbs)
            $this->scriptVbs[]=$whatScript;
        else
            $this->scriptJs[]=$whatScript;
    }
    function isJsPathHasLoad($whatJsPath) {
        $boolResult=false;
        foreach($this->jsPath as $val ) {
            if(strtolower($whatJsPath)==strtolower($val)) {
                $boolResult=true;
                break;
            }
        }
        return $boolResult;
    }

    function getInitJs() {
        if(count($this->initJs)==0) {
            ;
            return "";
        }else {
            return $this->initJs;
        }
    }
    function getInitVbs() {
        if(count($this->initJs)==0) {
            ;
            return "";
        }else {
            return $this->initVbs;
        }
    }
    function getScriptJs() {
        if(count($this->scriptJs)==0) {
            ;
            return "";
        }else {
            return $this->scriptJs;
        }
    }
    function getScriptVbs() {
        if(count($this->scriptVbs)==0) {
            ;
            return "";
        }else {
            return $this->scriptVbs;
        }
    }
    function addJsPath($whatJsPath) {
        if(!$this->isJsPathHasLoad($whatJsPath))
            $this->jsPath[count($this->jsPath)]=$whatJsPath;
    }
    function getJsPath() {
        if(count($this->jsPath)==0) {
            ;
            return "";
        }else {
            return $this->jsPath;
        }

    }
    function regScript($functionName,$value,$type="javascript",$ver="default") {
        $value=str_replace("\n","",$value);
        $value=str_replace(";",";\n",$value);
        $value=str_replace("{","{\n",$value);
        $value=str_replace("}","}\n",$value);
        if($type=="javascript") {
            $value="function ".$functionName."{\n".$value."}\n";
        }else {
            $value="sub ".$functionName."\n".$value."\nend sub\n";
        }
        if($type=="javascript") {
            if(!array_key_exists($functionName,$this->regJs)) {
                $this->regJs[$functionName]=array();
                $this->regJs[$functionName]["ver"]=$ver;
                $this->regJs[$functionName]["value"]=$value;
                if(!array_key_exists($ver,$this->regJsVer)) {
                    $this->regJsVer[$ver]=$ver;
                }
            }
        }else if($type=="vbscript") {
            if(!array_key_exists($functionName,$this->regVb)) {
                $this->regVb[$functionName]=$value;
            }
        }
    }
    function buildJs() {
        $tmpbuildJs="";
        $tmpbuildJsComplete=array();
        $tmpbuildVb="";
        if(count($this->regJs)) {
            if(count($this->jsFunction)>0) {
                foreach($this->jsFunction as $key=>$value) {
                    $this->regJs[$key]=array();
                    $this->regJs[$key]["ver"]="default";
                    $this->regJs[$key]["value"]=$value->build();
                    $this->regJs[$key]['script']="javascript";
                }
            }
            $jml=count($tmpbuildJsComplete);
            $tmpbuildJsComplete[$jml]=array();
            if($jml==0) {
                foreach($this->scriptJs as $value) {
                    $tmpbuildJs.=$value."\n";
                }
            }
            $tmpbuildJsComplete[$jml]['value'].=$tmpbuildJs."\n";
            $tmpbuildJs="";
            foreach($this->regJsVer as $valueVer) {
                foreach($this->regJs as $value) {
                    if($value['ver']==$valueVer) {
                        $tmpbuildJs.=$value['value'];
                    }
                }

                $tmpbuildJsComplete[$jml]['script']="javascript";
                $tmpbuildJsComplete[$jml]['ver']=($valueVer=="default")?"":$valueVer;
                $tmpbuildJsComplete[$jml]['value'].=$tmpbuildJs;
            }

        }else {
            if(count($this->scriptJs)) {
                $jml=count($tmpbuildJsComplete);
                foreach($this->scriptJs as $value) {
                    $tmpbuildJs.=$value."\n";
                }
                $tmpbuildJsComplete[$jml]=array();
                $tmpbuildJsComplete[$jml]['value'].=$tmpbuildJs."\n";
                $tmpbuildJsComplete[$jml]['script']="javascript";
                $tmpbuildJsComplete[$jml]['ver']="";
            }
            if(count($this->jsFunction)>0) {
                foreach($this->jsFunction as $key=>$value) {
                    $jml=count($tmpbuildJsComplete);
                    $tmpbuildJsComplete[$jml]=array();
                    $tmpbuildJsComplete[$jml]['value'].=$value->build()."\n";
                    $tmpbuildJsComplete[$jml]['script']="javascript";
                    $tmpbuildJsComplete[$jml]['ver']="";
                }
            }
        }
        $tmpbuildJs="";
        if(count($this->regVb)) {
            foreach($this->scriptVbs as $value) {
                $tmpbuildVb.=$value;
            }
            $tmpbuildVb.="\n";
            foreach($this->regVb as $value) {
                $tmpbuildVb.=$value;
            }
            $jml=count($tmpbuildJsComplete);
            $tmpbuildJsComplete[$jml]=array();
            $tmpbuildJsComplete[$jml]['ver']="";
            $tmpbuildJsComplete[$jml]['script']="vbscript";
            $tmpbuildJsComplete[$jml]['value']=$tmpbuildVb;
        }else {
            if(count($this->scriptVbs)) {
                $jml=count($tmpbuildJsComplete);
                foreach($this->scriptVbs as $value) {
                    $tmpbuildJs.=$value."\n";
                }
                $tmpbuildJsComplete[$jml]=array();
                $tmpbuildJsComplete[$jml]['value'].=$tmpbuildJs."\n";
                $tmpbuildJsComplete[$jml]['script']="vbscript";
                $tmpbuildJsComplete[$jml]['ver']="";
            }
        }
        $this->result=$tmpbuildJsComplete;
    }
    function getScriptName() {
        $tmpgetScriptName=array();
        foreach($this->result as $value) {
            $tmpgetScriptName[]=$value['script'];
        }
        return $tmpgetScriptName;
    }
    function getVersion() {
        $tmpgetVersion=array();
        foreach($this->result as $value) {
            $tmpgetVersion[]=$value['ver'];
        }
        return $tmpgetVersion;
    }
    function getValue() {
        $tmpgetValue=array();
        foreach($this->result as $value) {
            $tmpgetValue[]=$value['value'];
        }
        return $tmpgetValue;
    }

}
class jsFunction {
    private $jsscript=array();
    private $arg=array();
    private $name="";
    private $argObject=array();
    private $scriptTmp=array();
    private $scriptLast=array();
    private $scriptOnce=array();
    //var $scriptFuncTmp=array();
    function jsFunction($name) {
        $this->name=$name;
    }
    function getName() {
        return $this->name;
    }
    function addArg($argName,$argArdeaObject=null,$whatObjectToJs='value') {
        if($argArdeaObject!=null) {
            if(compareClassName("objectObject",$argArdeaObject)) {
                $this->argObject[]=$argArdeaObject->toJs($whatObjectToJs);
            }
        }
        $this->arg[]=$argName;
    }
    function getArg() {
        $tmpStr='';
        foreach($this->arg as $value) {
            if($value=="")
                $value="null";
            $tmpStr.=",".$value;
        }
        return substr($tmpStr,1);
    }
    /*
    function setObjectToArg($argNumber,$ardeaObject,$whatObjectToJs='value'){
        if(compareClassName("objectObject",$ardeaObject)){
          $this->argObject[$argNumber]=$ardeaObject->objectToJs($whatObjectToJs);
        }
    }
     *
    */
    function getArgForAction() {
        $tmpStr='';
        foreach($this->argObject as $value) {
            if($value=="")
                $value="null";
            $tmpStr.=",".$value;
        }

    }
    function addScriptOnce($id,$scriptStr) {
        $this->scriptOnce[$id]=$scriptStr."\n";
    }
    function addScriptTmp($script) {
        $this->scriptTmp[]=$script."\n";
    }
    function addScriptLast($script) {
        $this->scriptLast[]=$script."\n";
    }
    function getActionJs($withArg=true,$withQouteMark=true) {
        if($withArg) {
            if($withQouteMark)
                return  "\"".$this->name."(".$tmpStr.")\"";
            else
                return  $this->name."(".$tmpStr.")";
        }else {
            if($withQouteMark)
                return  "\"".$this->name."\"";
            else
                return  $this->name;
        }
    }

    function addScript($script) {
        $this->jsscript[]=$script."\n";
    }
    function getScript() {
        $tmpBuild="";
        foreach($this->jsscript as $value) {
            $tmpBuild.=$value;
        }
        foreach($this->scriptTmp as $valueScript) {
            $tmpBuild.=$valueScript;
        }
        return $tmpBuild;
    }
    function build() {
        $tmpBuild="";
        foreach($this->jsscript as $value) {
            //$tmpBuild=$value.$tmpBuild;
            $tmpBuild.=$value;
        }
        foreach($this->scriptTmp as $valueScript) {
            $tmpBuild.=$valueScript;
        }
        foreach($this->scriptLast as $valueScript) {
            $tmpBuild.=$valueScript;
        }
        foreach($this->scriptOnce as $key => $valueScript) {
            $tmpBuild.=$valueScript;
        }

        $tmpBuild="function ".$this->name."(".$this->getArg()."){\n".$tmpBuild."}\n";
        return $tmpBuild;
    }
}
class jsFile {
    private $script=array();
    private $name="";
    private $scriptFunc=array();
    private $scriptTmp=array();
    private $scriptLast=array();
    private $scriptFuncTmp=array();
    private $scriptFuncLast=array();
    private $fromFile=false;
    private $urlFile="";
    //public $data;
    function jsFile($fileName,$withSecurity=false) {
        global $ardeaCore;
        global $ardeaKM;
        $this->name=$fileName;

        if($withSecurity) {
            $key=$ardeaKM->getKey($ardeaCore->getURL('name'),'cJs',false);
            $ardeaCore->addJSPath($ardeaCore->getURL()."?optsc=a_s_c_r_".$key."&fl=".$fileName.$ardeaCore->getURLARG());
        }else {
            $ardeaCore->addJSPath($ardeaCore->getURL()."?optsc=cJs&fl=".$fileName.$ardeaCore->getURLARG());
        }
    }
    function setDataFromFile($urlFile) {
        $this->fromFile=true;
        $this->urlFile=$urlFile;
    }
    function addScript($script) {
        $this->script[]=$script;
    }
    function addScriptTmp($script,$funcName="") {
        if($funcName=="") {
            $this->scriptTmp[]=$script;
        }else {
            if(!array_key_exists($funcName,$this->scriptFuncTmp))
                $this->scriptFuncTmp[$funcName]=array();
            $this->scriptFuncTmp[$funcName][]=$script;
        }
    }
    function addScriptLast($script,$funcName="") {
        if($funcName=="") {
            $this->scriptLast[]=$script;
        }else {
            if(!array_key_exists($funcName,$this->scriptFuncLast))
                $this->scriptFuncLast[$funcName]=array();
            $this->scriptFuncLast[$funcName][]=$script;
        }
    }
    function getScriptTmp($loadOnObject="") {
        if($loadOnObject=="") {
            return $this->scriptTmp;
        }else {
            if(!array_key_exists($loadOnObject,$this->scriptFuncTmp))
                $this->scriptFuncTmp[$loadOnObject]=array();
            return $this->scriptFuncTmp[$loadOnObject][]=$script;
        }
    }

    //function reste
    function getName() {
        return $this->name;
    }
    function create() {
        $data="";
        if(!$this->fromFile) {
            global $ardeaCore;
            foreach($this->script as $value) {
                $data.=$value."\n";
            }
            if(count($this->scriptTmp)) {
                foreach($this->scriptTmp as $value) {
                    $data.=$value."\n";
                }
            }
            if(count($this->scriptLast)) {
                foreach($this->scriptLast as $value) {
                    $data.=$value."\n";
                }
            }
            foreach($this->scriptFunc as $key =>$value) {
                if(array_key_exists($key,$this->scriptFuncTmp)) {
                    foreach($this->scriptFuncTmp[$key] as $valueScript) {
                        $value->addScript($valueScript);
                    }
                }
                if(array_key_exists($key,$this->scriptFuncLast)) {
                    foreach($this->scriptFuncLast[$key] as $valueScript) {
                        $value->addScript($valueScript);
                    }
                }
                $data.=$value->build();
            }
            //$this->data=$data;
            $ardeaCore->setJsFileScriptTmp($data);
            //die(var_dump($data)."asasas");
        }else {

            if($this->$urlFile=="") {
                //die("ERROR path not defined");
            }
            //echo $this->path.$TemplateName."/index.php";
            //die($this->path.$TemplateName."/index.php");

            if ( file_exists( $this->$urlFile) ) {
                ob_start();
                include( $this->$urlFile);
                $data = ob_get_contents();
                ob_end_clean();
            }

        }
        echo $data;
    }
    function getFunction($funcName) {
        if(array_key_exists($funcName,$this->scriptFunc))
            return $this->scriptFunc[$functionName];
    }
    function addFunction($functionName,$arg="") {
        return $this->scriptFunc[$functionName]=new jsFunction($functionName);
    }

}

?>
