<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaSession.php
 * Date    : 
 * Used for: Basic library for Session
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class _ardeaSession {
    private $option=array();
    public $loginValid=false;
    function __construct() {
        session_cache_expire(30);
        session_start();
        //die(var_dump($_SESSION));
    }
    private  function getTIDLoginSession($url) {
        $data=$this->_getVar("ardea_login.user_data");
        if(is_array($data)) {
            foreach($data as $key => $value) {
                if($value["url"]==$url) {
                    return $key;
                }
            }
        }
        return "";
    }
    private function init_login($user,$urlDirection,$tid,$url_start) {
        $ip = $_SERVER['REMOTE_ADDR'];
        $user_agent = !empty($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "";
        //$urlDirection=fixRealPath($urlDirection);
        $dataLogin=array();
        $dataLogin[$tid]=array();
        $dataLogin[$tid]["user"]=$user;
        $dataLogin[$tid]["url"]=$urlDirection;
        $dataLogin[$tid]["url_start"]=$url_start;
        $dataLogin[$tid]["tid"]=$tid;
        if(!ereg("proxy\.aol\.com$", gethostbyaddr($ip))) {//if surfer's ISP is not AOL
            if($this->isSetVar("ardea_login")) {
                $user_data=$this->_getVar("ardea_login.user_data");
                $tid=$this->getTIDLoginSession($urlDirection);
                if($tid!="") {
                    $user_data[$tid]=array();
                    $user_data[$tid]["user"]=$user;
                    $user_data[$tid]["url"]=$urlDirection;
                    $user_data[$tid]["url_start"]=$url_start;
                    $user_data[$tid]["tid"]=$tid;
                }else {
                    if(is_array($user_data))
                        $user_data=array_merge($user_data,$dataLogin);
                }
                $this->setVar("ardea_login.user_data",$user_data);
                $this->loginValid = true;
                //$this->clear();
                //die(var_dump($_SESSION));
            }else {
                $this->setVar("ardea_login", array());
                $this->setVar("ardea_login.ip", $ip);
                $this->setVar("ardea_login.user_agent",$user_agent);
                $this->setVar("ardea_login.user_data",$dataLogin);
                $this->loginValid = true;
            }
        }else {//if surfer's ISP is AOL, we can't verify IP adress
            if(!$this->isSetVar("ardea_login")) {
                $this->setVar("ardea_login", array());
                $this->setVar("ardea_login.ip", $ip);
                $this->setVar("ardea_login.user_agent", $user_agent);
                $this->setVar("ardea_login.user_data",$dataLogin);
                $this->loginValid = true;
            }
        }

    }
    function initLogin() {
        global $ardeaCore;
        loadLib("lib.core.ardeaURL");
        loadLib("lib.core.ardeaCookies");
        $ip = $_SERVER['REMOTE_ADDR'];
        $user_agent = !empty($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : "";
        $url=ardeaURL::URL("folder");
        //$this->clear();
        //var_dump($url);
        //var_dump($_SESSION);
        $user=null;
        $ck=new ardeaCookieSession();
        $tid=$this->getTIDLoginSession($url);
        $data=$this->_getVar("ardea_login.user_data");
        $user=$data[$tid]["user"];

        if($this->isSetVar("ardea_login")&&$tid!="") {

            if($ip == $this->_getVar("ardea_login.ip") && $user_agent == $this->_getVar("ardea_login.user_agent")) {
                $this->loginValid = true;
            }else {
                $this->loginValid = false;
            }
        }else {
            $this->loginValid = false;
        }
        loadApplication("login",true);
    }
    function setVar($name, $value) {
        $expr = $this->getNames($name);
        $expr .= " = \$value;";
        //die($expr." ".$value);
        eval($expr);
    }
    function login($user,$urlDirection,$tid,$url_Start) {
        $this->init_login($user,$urlDirection,$tid,$url_Start);
    }
    function logout($tid) {
        global $ardeaCore;
        loadLib("lib.core.ardeaURL");
        loadLib("lib.core.ardeaCookies");
        $ck=new ardeaCookieSession();
        $data=$this->_getVar("ardea_login.user_data");
        unset($data[$tid]);
        $this->setVar("ardea_login.user_data",$data);
        //die(var_dump($data));
        if(count($data)===0) {
            $this->unsetVar("ardea_login.ip");
            $this->unsetVar("ardea_login.user_agent");
            $this->unsetVar("ardea_login.user_data");
            $this->unsetVar("ardea_login");
        }
    }

    function _getVar($name) {
        if($this->isSetVar($name)) {
            $result = eval("return ".$this->getNames($name).";");
            return $result;
        }
        return false;
    }

    function unsetVar($name) {
        if( $this->isSetVar($name) ) {
            $var = $this->getNames($name);
            eval("unset($var);");
            return true;
        }
        return false;
    }

    function isSetVar($name) {
        $expr = "return isset(".$this->getNames($name).");";
        return eval($expr);
    }
    private function getNames($name) {
        if(is_string($name)) {
            $nm=$names;
            if(strpos($name, "."))//S'il y a un "." dans le nom de la variable  stocker dans la session, c'est qu'on veut stocker un tableau
                $names = explode(".", $name);
            else
                $names = array($name);

            $expr = $expr = "\$_SESSION";
            foreach($names as $item)
                $expr.= is_numeric($item) ? "[$item]" : "['$item']";
            return $expr;
        }
        return false;
    }
    function ardeaSession() {
        $this->option=argToOption(func_get_args());
    }
    function getVar($varName) {
        global $_SESSION;
        //die(var_dump($_SESSION));
        if(array_key_exists($varName,$_SESSION)) {
            return $_SESSION[$varName];
        }
        return false;
    }
    function getloginValid() {
        return $this->loginValid;
    }
    function reg($var) {
        session_register($var);
    }
    function unreg($var) {
        session_unregister($var);
    }
    function clear() {
        session_unset();
    }
    function start() {
        session_start();
    }
    function destroy() {
        return session_destroy();
    }
    function id() {
        return session_id();
    }
    function setExpire($valueOfExpire) {
        if(is_numeric($valueOfExpire))
            session_cache_expire($valueOfExpire);
    }
    function renewId() {
        session_regenerate_id();
    }
}
?>
