<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaThemes.php
 * Date    : 
 * Used for: Basic library for Theme
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/    
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
define("THEMES_BUTTON",1);
define("THEMES_LABEL",2);
define("THEMES_INPUT",3);
loadLib("lib.core.ardeaSimpleXML");
class ardeaThemes {
    private $pathOfCss=array();
    private $tmpArrThemes=array();
    private $tmpArrClass=array();
    private $jmlPathOfCss=0;
    private $labelProperty;
    private $inputProperty;
    private $buttonProperty;
    private $xml;
    function ardeaThemes() {
        $this->labelProperty=new ardeaExtendProperty();
        $this->buttonProperty=new ardeaExtendProperty();
        $this->inputProperty=new ardeaExtendProperty();
        $this->tmpArrClass["label"]="def_label";
        $this->tmpArrClass["input"]="def_input";
        $this->tmpArrClass["button"]="def_button";
        $this->xml=new ardeaXML();
    }

    function __clone() {
        $this->labelProperty=clone($this->labelProperty);
        $this->buttonProperty=clone($this->buttonProperty);
        $this->inputProperty=clone($this->inputProperty);
        $this->tmpArrClass["label"]="def_label";
        $this->tmpArrClass["input"]="def_input";
        $this->tmpArrClass["button"]="def_button";
    }


    function openXMLThemes($fileName="defaultThemes") {
        $this->xml->openFile(ARDEA_CORE_XML."themes/".$fileName.".xml");
        foreach($this->xml->xml as $key => $value ) {
            foreach($value as $key_child => $value_child  ) {
                foreach($value_child as $key_child_1 => $value_child_1  ) {
                    //print_r($value_child_1);
                    if($key=="button_property") {
                        //echo "a".$value_child_1;
                        //foreach($value_child_1 as $key_child_value => $value_child_value  ) {

                        $this->setButtonProperty($key_child_1, $value_child_1 ,$key_child);
                        //}
                    }
                    if($key=="label_property") {
                        //foreach($value_child_1 as $key_child_value => $value_child_value  ) {
                        $this->setLabelProperty($key_child_1, $value_child_1 ,$key_child);
                        ///}
                    }
                    if($key=="input_property") {
                        //foreach($value_child_1 as $key_child_value => $value_child_value  ) {
                        $this->setInputProperty($key_child_1, $value_child_1 ,$key_child);
                        //    }
                    }
                }
            }
        }
    }

    function toString() {
        return "ardea Themes";
    }
    function setLabelPropertyObject($objectLabelProperty) {
        global $ardeaCore;
        if(!is_object($objectLabelProperty))
            $ardeaCore->setError("setLabelProperty","Function buildObject on Object Not found","objectObject/ardeaObject.php");
        $this->labelProperty=clone $objectLabelProperty;
    }
    function setLabelProperty($propertyName,$value="",$parentProperty="") {
        $this->labelProperty->setProperty($propertyName,$value,$parentProperty);
    }
    function getLabelProperty($propertyName,$parentProperty="") {
        return $this->labelProperty->getProperty($propertyName,$parentProperty);
    }
    function setInputPropertyObject($objectInputProperty) {
        if(!is_object($objectInputProperty))
            $ardeaCore->setError("setInputProperty","Function buildObject on Object Not found","objectObject/ardeaObject.php");
        $this->inputProperty=clone $objectInputProperty;
    }
    function setInputProperty($propertyName,$value="",$parentProperty="") {
        $this->inputProperty->setProperty($propertyName,$value,$parentProperty);
    }
    function getInputProperty($propertyName,$parentProperty="") {
        return $this->inputProperty->getProperty($propertyName,$parentProperty);
    }

    function setButtonPropertyObject($objectButtonProperty) {
        if(!is_object($objectButtonProperty))
            $ardeaCore->setError("setButtonProperty","Function buildObject on Object Not found","objectObject/ardeaObject.php");
        $this->buttonProperty=clone $objectButtonProperty;
    }

    function setButtonProperty($propertyName,$value="",$parentProperty="") {
        $this->buttonProperty->setProperty($propertyName,$value,$parentProperty);
    }
    function getButtonProperty($propertyName,$parentProperty="") {
        return $this->buttonProperty->getProperty($propertyName,$parentProperty);
    }
    function getButtonPropertyObject() {
        return $this->buttonProperty;
    }
    function getLabelPropertyObject() {
        return $this->labelProperty;
    }
    function getInputPropertyObject() {
        return $this->inputProperty;
    }
    function setLabelClass($newStringClass) {
        $this->tmpArrClass["label"]=$newStringClass;
    }
    function getLabelClass() {
        return $this->tmpArrClass["label"];
    }

    function setInputClass($newStringClass) {
        $this->tmpArrClass["input"]=$newStringClass;
    }
    function getInputClass() {
        return $this->tmpArrClass["input"];
    }
    function setButtonClass($newStringClass) {
        $this->tmpArrClass["button"]=$newStringClass;
    }
    function getButtonClass() {
        return $this->tmpArrClass["button"];
    }
    function buildButtonProperty() {
        return $this->buttonProperty->buildProperty();
    }
    function buildInputProperty() {
        return $this->inputProperty->buildProperty();
    }
    function buildLabelProperty() {
        return $this->labelProperty->buildProperty();
    }
}

?>