<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaURL.php
 * Date    : 
 * Used for: Basic library for URL
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/    
/**
 * @version		2.0
 * @package		lib
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class ardeaURL {
    function ardeaURL() {
    }
    function changeThemesURL($newURL) {
        define("ARDEA_CORE_PATH_THEMES_ROOT",$newURL);

        define("ARDEA_CORE_PATH_IMAGE_ROOT",ARDEA_CORE_PATH_THEMES_ROOT."images/");
        define("ARDEA_CORE_PATH_IMAGE",ARDEA_CORE_PATH_IMAGE_ROOT."core/");
        define("ARDEA_CORE_PATH_PLUGIN_IMAGE",ARDEA_CORE_PATH_IMAGE_ROOT."plugin/");

        define("ARDEA_CORE_PATH_JS_ROOT",ARDEA_CORE_PATH_THEMES_ROOT."js/");
        define("ARDEA_CORE_PATH_JS",ARDEA_CORE_PATH_JS_ROOT."core/");
        define("ARDEA_CORE_PATH_PLUGIN_JS",ARDEA_CORE_PATH_JS_ROOT."plugin/");

        define("ARDEA_CORE_PATH_CSS_ROOT",ARDEA_CORE_PATH_THEMES_ROOT."css/");
        define("ARDEA_CORE_PATH_CSS",ARDEA_CORE_PATH_CSS_ROOT."core/");
        define("ARDEA_CORE_PATH_PLUGIN_CSS",ARDEA_CORE_PATH_CSS_ROOT."plugin/");
    }
    function getURLJS($fileOfJS,$isPlugin=false) {
        if($isPlugin) {
            return ARDEA_CORE_DOMAIN.ARDEA_CORE_PATH_PLUGIN_JS.$fileOfJS;
        }else {
            return ARDEA_CORE_DOMAIN.ARDEA_CORE_PATH_JS.$fileOfJS;
        }
    }
    function getURLCSS($fileOfCss,$isPlugin=false) {
        if($isPlugin) {
            return ARDEA_CORE_DOMAIN.ARDEA_CORE_PATH_PLUGIN_CSS.$fileOfCss;
        }else {
            return ARDEA_CORE_DOMAIN.ARDEA_CORE_PATH_CSS.$fileOfCss;
        }
    }
    function getURLIMAGE($fileOfImage,$isPlugin=false) {
        if($isPlugin) {
            return ARDEA_CORE_DOMAIN.ARDEA_CORE_PATH_PLUGIN_IMAGE.$fileOfImage;
        }else {
            return ARDEA_CORE_DOMAIN.ARDEA_CORE_PATH_IMAGE.$fileOfImage;
        }
    }
    function getURL($opt="all") {
        return $this->URL($opt);
    }

    public static function URL($opt="all") {
        $URL="http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
        switch ($opt) {
            case "all":
                return $URL;
                break;
            case "name":
            //die($URL);
                $tmp_getURL=parse_url($URL);
                $tmp_getURL=$tmp_getURL['path'];
                $tmp_getURL=split("/",$tmp_getURL);
                return $tmp_getURL[count($tmp_getURL)-1];
                //return $tmp_getURL;
                break;
            case "path":
                $tmp_getURL=parse_url($URL);
                $tmp_getURL=$tmp_getURL['path'];
                return $tmp_getURL;
            case "host":
                $tmp_getURL=parse_url($URL);
                $tmp_getURL=$tmp_getURL['host'];
                return $tmp_getURL;
                break;
            case "folder":
                $tmp_getURL=substr($URL,0,strrpos($URL,"/"));
                return $tmp_getURL."/";
                break;
            case "query":
                $tmp_getURL=parse_url($URL);
                $tmp_getURL=$tmp_getURL['query'];
                return $tmp_getURL;
                break;
            case "server_name":
                return getServerName();
                break;
            case "server_address":
                return getServerAddress();
                break;
            case "doc_root":
                return getDocRoot();
                break;
        }

    }

}
function getServerName() {
    global $_SERVER;
    //var_dump($_SERVER);
    return $_SERVER['HTTP_HOST'];
}
function getPath() {
    global $_SERVER;
    //global $HTTP_SERVER_VARS;
    return $_SERVER['PHP_SELF'];
}
function getServerAddress() {
    global $HTTP_SERVER_VARS;
    return $HTTP_SERVER_VARS['SERVER_ADDR'];
}
function getDocRoot() {
    global $HTTP_SERVER_VARS;
    return $HTTP_SERVER_VARS['DOCUMENT_ROOT'];
}
?>
