<?php
/**
 * @version		2.0
 * @package		lib.core
 * @subpackage	blog
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
if(!class_exists("registry"))
    loadLib("lib.core.ardeaRegistry");
class article {
    protected $conf=null;
    protected $db=null;
    protected $data=null;
    protected $method="post";
    protected $tableName="article";
    protected $rs=null;
    protected $limit=5;
    //protected $recordLength=5;
    function article($dbConf=null) {
        global $ardeaCore;
        global $cmsData;
        if($dbConf!=null) {
            $this->conf=$dbConf;
            $this->db=$ardeaCore->getDb($conf);
        }
        $this->tableName=$cmsData->getParam("prefix").$this->tableName;
        $this->data=new dataArticle;
    }
    function getTableName() {
        return $this->tableName;
    }
    function getDbConf() {
        return $this->conf;
    }
    function & getDb() {
        return $this->db;
    }

    function setMethodeRequest($newMethod) {
        $this->method=$newMethod;
    }
    function setTableName($newTableName) {
        $this->tableName=$newTableName;
    }

    function setDBConf($newDbConf) {
        $this->conf=$newDbConf;
        $this->db=$ardeaCore->getDb($conf);
    }
    private function isConnect() {
        if($this->db->hasConnect()) {
            return true;
        }
        return false;
    }
    function getData() {
        return $this->data;
    }
    function add($dataArticleClass) {
        if(!$this->isConnect())
            return false;
        $this->data->initDataFormRequest($this->method);
        $dataDb=$this->data->getDataToDb();
        //$fld=registry::getValue("/root/system/setting/prefix");
        $this->db->autoExecute($this->tableName,"INSERT",$dataDb);
        $fld=array();
        $fld["date_created"]=$dataDb["created"];
        $fld["article_id"]=$dataDb["id"];
        $this->db->autoExecute($this->tableName."_log","INSERT",$fld);
    }
    function delete($id) {
        if(!$this->isConnect())
            return false;
        $fields=array("id"=>$id);
        $this->db->autoExecute($this->tableName,"DELETE",$fields);
        $fields=array("article_id"=>$id);
        $this->db->autoExecute($this->tableName."_log","DELETE",$fields);
    }
    function get($page) {
        if(!$this->isConnect())
            return false;
        $this->rs=$this->db->autoExecute($this->tableName,"SELECT");
        if($this->rs->fields) {
            $cmsData->setParam("data_length",$this->rs->recordCount());
            $cmsData->setParam("data_limit",$this->limit);
            $this->rs->gotoRecord($page);
            $this->data->getDataFromDb($rs->fields);
            $cmsData->setParam("data",$this->data);
        }
        return $this->data;
    }
    //function
    function getId() {
        if(!$this->isConnect())
            return false;
        $this->data->id;
    }
    function next() {
        if(!$this->isConnect())
            return false;
        if($this->rs!=null&&$this->rs->fields) {
            $this->rs->next();
            $this->data->getDataFromDb($rs->fields);
            $cmsData->setParam("data",$this->data);
        }
    }
}

class dataArticle {
    public $id="";
    public $title="";
    public $introtext="";
    public $completetext="";
    public $state="";
    public $sectionid="";
    public $catid="";
    public $created="";
    public $created_by="";
    public $modified="";
    public $modified_by="";
    public $publish_up="";
    public $publish_down="";
    public $parentid="";
    public $ordering="";
    public $access="";
    public $hits="";
    function getText() {
        return $this->introtext.$this->completetext;
    }
    function isReadMore() {
        if($this->completetext!="")
            return true;
        return false;
    }
    function getDataFromDb($dbFields) {
        $this->id="";
        if(array_key_exists("id",$dbFields))
            $this->id=$dbFields["id"];
        $this->title="";
        if(array_key_exists("title",$dbFields))
            $this->title=$dbFields["title"];
        $this->introtext="";
        if(array_key_exists("introtext",$dbFields))
            $this->introtext=$dbFields["introtext"];
        $this->completetext="";
        if(array_key_exists("completetext",$dbFields))
            $this->completetext=$dbFields["completetext"];
        $this->state="";
        if(array_key_exists("state",$dbFields))
            $this->state=$dbFields["state"];
        $this->sectionid="";
        if(array_key_exists("sectionid",$dbFields))
            $this->sectionid=$dbFields["sectionid"];
        $this->catid="";
        if(array_key_exists("catid",$dbFields))
            $this->catid=$dbFields["catid"];
        $this->created="";
        if(array_key_exists("created",$dbFields))
            $this->created=$dbFields["created"];
        $this->created_by="";
        if(array_key_exists("created_by",$dbFields))
            $this->created_by=$dbFields["created_by"];
        $this->modified="";
        if(array_key_exists("modified",$dbFields))
            $this->modified=$dbFields["modified"];
        $this->modified_by="";
        if(array_key_exists("modified_by",$dbFields))
            $this->modified_by=$dbFields["modified_by"];
        $this->publish_up="";
        if(array_key_exists("publish_up",$dbFields))
            $this->publish_up=$dbFields["publish_up"];
        $this->publish_down="";
        if(array_key_exists("publish_down",$dbFields))
            $this->publish_down=$dbFields["publish_down"];
        $this->parentid="";
        if(array_key_exists("parentid",$dbFields))
            $this->parentid=$dbFields["parentid"];
        $this->ordering="";
        if(array_key_exists("ordering",$dbFields))
            $this->ordering=$dbFields["ordering"];
        $this->access="";
        if(array_key_exists("access",$dbFields))
            $this->access=$dbFields["access"];
        $this->hits="";
        if(array_key_exists("hits",$dbFields))
            $this->hits=$dbFields["hits"];
    }
    function initDataFormRequest($whatMethod="post") {
        if($whatMethod=="post") {
            $this->getDataFromDb($_POST);
        }else {
            $this->getDataFromDb($_GET);
        }
    }
    function getDataToDb() {
        $dataArr=array();
        $dataArr["id"]="";
        if($this->id!="")
            $dataArr["id"]=$this->id;
        $dataArr["title"]="";
        if($this->title!="")
            $dataArr["title"]=$this->title;
        $dataArr["introtext"]="";
        if($this->introtext!="")
            $dataArr["introtext"]=$this->introtext;
        $dataArr["completetext"]="";
        if($this->completetext!="")
            $dataArr["completetext"]=$this->completetext;
        $dataArr["state"]="";
        if($this->state!="")
            $dataArr["state"]=$this->state;
        $dataArr["sectionid"]="";
        if($this->sectionid!="")
            $dataArr["sectionid"]=$this->sectionid;
        $dataArr["catid"]="";
        if($this->catid!="")
            $dataArr["catid"]=$this->catid;
        $dataArr["created"]="";
        if($this->created!="")
            $dataArr["created"]=$this->created;
        $dataArr["created_by"]="";
        if($this->created_by!="")
            $dataArr["created_by"]=$this->created_by;
        $dataArr["modified"]="";
        if($this->modified!="")
            $dataArr["modified"]=$this->modified;
        $dataArr["modified_by"]="";
        if($this->modified_by!="")
            $dataArr["modified_by"]=$this->modified_by;
        $dataArr["publish_up"]="";
        if($this->publish_up!="")
            $dataArr["publish_up"]=$this->publish_up;
        $dataArr["publish_down"]="";
        if($this->publish_down!="")
            $dataArr["publish_down"]=$this->publish_down;
        $dataArr["parentid"]="";
        if($this->parentid!="")
            $dataArr["parentid"]=$this->parentid;
        $dataArr["ordering"]="";
        if($this->ordering!="")
            $dataArr["ordering"]=$this->ordering;
        $dataArr["access"]="";
        if($this->access!="")
            $dataArr["access"]=$this->access;
        $dataArr["hits"]="";
        if($this->hits!="")
            $dataArr["hits"]=$this->hits;
    }
}
?>
