<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaAbout.php
 * Date    : 
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component 
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
loadLib("lib.core.ardeaObject");
loadLib("lib.plugin.JSON.JSON");
class ardeaAjax extends objectObject {
    public $method="GET";
    private $func=array();
    private $meth=array();
    private $param=array();
    private $ajaxParam=array();
    //gunakan true jika ingin request masuk kedalam function pada argument pertama
    public $ajaxParamUseRequest=false;
    public $procAjax="";
    public $JSON="";
    public $request="";
    public $useJSArg=false;
    //for db
    private $typeDb='mysql';
    private $tblName=null;
    private $opt=null;
    private $wh=null;
    private $recUseSecurity=false;
    //var $
    public $FOC=array();
    public $AUTO_FOC=true;
    private $defaultProcessFunction="ajaxProcess";
    private $defaultProcessFunctionDB="ajaxProcessDb";


    function ardeaAjax($method="get") {
        global $ardeaCore;
        parent::__construct();
        if(strtolower($method)=="get")
            $this->method="GET";
        else
            $this->method="POST";
        $this->procAjax=new processAjax();
        $this->JSON=new JSON();
        $this->initOnly();
        $this->setNoBuildProperty();
        $ardeaCore->addJSPath($ardeaCore->getURLJS('ardeaAjax.js'));
        $ardeaCore->addJSPath($ardeaCore->getURLJS('json.js'));
    }
    function registerVar() {

    }
    function setDefaultNameFunction($newNameFunction) {
        $this->defaultProcessFunction=$newNameFunction;
    }
    function setDefaultNameFunctionDb($newNameFunction) {
        $this->defaultProcessFunctionDB=$newNameFunction;
    }
    function setAutoFOC($boolFOC=true) {
        $this->AUTO_FOC=$boolFOC;
        $this->procAjax->AUTO_FOC=$boolFOC;
    }
    function recordFieldUseSecurity() {
        $this->recUseSecurity=true;
    }
    function setTypeDb($newTypeDb) {
        $this->typeDb=$newTypeDb;
    }
    function SetAutoDb($tableName,$opt="INSERT",$wh=null) {
        $this->tblName=$tableName;
        $this->opt=$opt;
        $this->wh=$wh;
    }
    function registerFunction($funcName,$url='',$callBackJs='',$urlArg='') {
        if(isValidFunction($funcName)) {
            if(!in_array($funcName,$this->func)) {
                $this->func[]=$funcName;
                $this->ajaxParam[$funcName]=array();
                $this->ajaxParam[$funcName]['url']=$url;
                $this->ajaxParam[$funcName]['callbackjs']=$callBackJs;
                $this->ajaxParam[$funcName]['urlarg']=$urlArg;
            }
        }

    }
    function registerClass($className,$url='',$callBackJs='') {
        if(isClassExist($className)) {
            $classMethod=get_class_methods($className);
            foreach($classMethod as $name) {
                $this->registerMethod($className,$name,$url,$callBackJs);
            }
        }
    }
    function registerMethod($className,$methodName,$url='',$callBackJs='',$urlArg='') {
        if(isValidClassAndMethod($className,$methodName)) {

            if(!array_key_exists($className,$this->meth))
                $this->meth[$className]=array();

            if(!in_array($methodName,$this->meth[$className])) {
                $this->meth[$className][]=$methodName;
                $this->ajaxParam[$className.".".$methodName]=array();
                $this->ajaxParam[$className.".".$methodName]['url']=$url;
                $this->ajaxParam[$className.".".$methodName]['callbackjs']=$callBackJs;
                //$urlArg=($urlArg=="")?"\"\"":$urlArg;
                $this->ajaxParam[$className.".".$methodName]['urlarg']=$urlArg;

            }
        }
    }
    function setUseJSArg() {
        $this->useJSArg=true;
    }


    private function buildParam($className='none',$methodName) {
        $tmpStr=array();
        if($className=='none') {
            $paramName=$methodName;
            $reflectionMethod = new ReflectionFunction($methodName);
        }else {
            $paramName=$className.".".$methodName;
            $class = new ReflectionClass($className);
            $reflectionMethod = $class->getMethod( $methodName );
        }
        $tmpArg=$reflectionMethod->getParameters();
        foreach($tmpArg as $key => $value) {
            $tmpStr[]=$tmpArg[$key]->getName();
        }
        $this->param[$paramName]=$tmpStr;
    }
    private function getParamString($className=null,$methodName) {
        $tmp=$this->getParam($className,$methodName);
        $tmpStr='';
        foreach($tmp as $val) {
            $tmpStr.="\"".$val."\",";
        }
        return substr($tmpStr,1,strlen($tmpStr)-1);
    }
    private function getParam($className=null,$methodName) {
        if($className==null) {
            $paramName=$methodName;
        }else {
            $paramName=$className.".".$methodName;
        }
        return $this->param[$paramName];
    }
    function isAjaxRun() {
        if($this->method=="GET") {
            if(array_key_exists("aj",$_GET)) {
                return true;
            }
        } else {
            if(array_key_exists("aj",$_POST)) {
                return true;
            }
        }
        return false;
    }
    function isRequest() {
        if($this->method=="GET") {
            if(array_key_exists("aj",$_GET)) {
                //die( $this->JSON->decode(stripslashes($_GET["aj"])));
                $this->request=$this->JSON->decode( stripslashes($_GET["aj"]));
                return true;
            }
        } else {
            if(array_key_exists("aj",$_POST)) {
                $this->request=$this->JSON->decode( stripslashes($_POST["aj"]));
                return true;
            }
        }
        return false;
    }
    function getRequest() {
        return $this->request;
    }

    function process($write=false) {
        $this->procAjax->setDefaultNameFunction($this->defaultProcessFunction);
        $this->procAjax->setDefaultNameFunctionDb($this->defaultProcessFunctionDB);
        $this->procAjax->process($this);

        if(!$write)
            return $this->JSON->encode($this->procAjax);
        else
            echo $this->JSON->encode($this->procAjax);

        die();
    }
    function addFOC($className=null,$funcName=null,$funcJs) {
        if($className==null&&$funcName==null) {
            $funcName="root";
        }elseif($className==null) {
            if(strpos($funcName,".")>-1) {
                $funcArr=explode(".",$funcName);
                $funcName=$funcArr[0].".".$funcArr[1];
            }

        }else {
            $funcName=$className.".".$funcName;
        }
        if(!array_key_exists($id,$this->FOC))
            $this->FOC[$funcName]=array();
        $this->FOC[$funcName][]=$funcJs;
    }
    function getFOC($className=null,$funcName=null) {
        if($className==null&&$funcName==null) {
            $funcName="root";
        }elseif($className==null) {
            if(strpos($funcName,".")>-1) {
                $funcArr=explode(".",$funcName);
                $funcName=$funcArr[0].".".$funcArr[1];
            }

        }else {
            $funcName=$className.".".$funcName;
        }
        $tmpStr=array();
        foreach($this->FOC as $key => $value) {
            if($key==$funcName) {
                foreach($value as $subValue)
                    $tmpStr[]=$subValue;
                break;
            }
        }
        return $tmpStr;
    }
    function getProcess() {
        return  $this->procAjax;
    }

    function setAjaxParam($className=null,$funcName=null,$urlName='',$callBackJS='') {
        if($className==null&&$funcName==null)
            return;
        $option=argToOption(func_get_args(),"url,callbackjs");
        $url=getOption($option,"url",2);
        $callBackJS=getOption($option,"callbackjs",3);
        if($className==null) {
            if(!array_key_exists($funcName,$this->ajaxParam))
                return ;
            if($url!='')
                $this->ajaxParam[$funcName]['url']=$url;
            if($callBackJS!='')
                $this->ajaxParam[$funcName]['callbackjs']=$callBackJS;
        }else {
            if(!array_key_exists($className.".".$funcName,$this->ajaxParam))
                return ;
            if($url!='')
                $this->ajaxParam[$className.".".$funcName]['url']=$url;
            if($callBackJS!='')
                $this->ajaxParam[$className.".".$funcName]['callbackjs']=$callBackJS;
        }
    }
    function getAjaxParam($className=null,$funcName=null,$paramName) {
        ///die(var_dump($this->ajaxParam));
        if($className==null&&$funcName==null)
            return null;
        if($className==null) {
            if(strpos($funcName,".")>-1) {
                $funcArr=explode(".",$funcName);
                $funcName=$funcArr[0].".".$funcArr[1];
            }
            if(array_key_exists($funcName,$this->ajaxParam)) {
                if(!array_key_exists(strtolower($paramName),$this->ajaxParam[$funcName]))
                    return null;
                return $this->ajaxParam[$funcName][strtolower($paramName)];
            }
        }else {
            $funcName=$className.".".$funcName;

            if(array_key_exists($funcName,$this->ajaxParam)) {
                if(!array_key_exists(strtolower($paramName),$this->ajaxParam[$funcName]))
                    return null;
                return $this->ajaxParam[$funcName][strtolower($paramName)];
            }
        }
    }
    protected function buildObject() {
        if(!$this->buidJsOnBody) {
            $this->addJsFile('initAjax',true,false,true);
        }
    }
    protected function buildJs() {
        global $ardeaCore;
        global $_ARDEA_CONFIG;
        foreach($this->ajaxParam as $key=>$value) {
            if(!array_key_exists('url',$value)) {
                $tmpArr=explode(".",$key);
                if(count($tmpArr)==1)
                    $this->setAjaxParam(null,$tmpArr[0],$ardeaCore->getURL('name'));
                else
                    $this->setAjaxParam($tmpArr[0],$tmpArr[1],$ardeaCore->getURL('name'));
            }else {
                if($value['url']=='') {
                    $tmpArr=explode(".",$key);
                    if(count($tmpArr)==1)
                        $this->setAjaxParam(null,$tmpArr[0],$ardeaCore->getURL('name'));
                    else
                        $this->setAjaxParam($tmpArr[0],$tmpArr[1],$ardeaCore->getURL('name'));
                }
            }
        }
        $this->writeJs();
    }
    private function writeJs() {
        global $ardeaCore;
        global $_initJs;
        global $_VAR_FILE_;

        /*
          if(!$this->buidJsOnBody){
               if($_ARDEA_CONFIG["security_on"])   
                $fileJS=$ardeaCore->createJsFile('initAjax',true);
               else
                $fileJS=$ardeaCore->createJsFile('initAjax');
          }
        */
        if($this->isHaveJs($script,$_VAR_FILE_)||$_VAR_FILE_=='ardeaBaseInit') {

            //die(var_dump($this->func));
            foreach($this->func as $val) {
                //die($key.".".$valMethod);
                $urlArg=$this->getAjaxParam(null,$val,'urlarg');
                $urlArg=($urlArg=="")?"\"\"":$urlArg;
                $contain="ardeaAjax.setDataFunc(null,'".$val."',arguments,".$urlArg.")\n";

                if($this->getAjaxParam(null,$val,'callBackJS')=="")
                    $contain.="ardeaAjax.call('".$this->method."','".$this->getAjaxParam(null,$val,'url')."','')";
                else
                    $contain.="ardeaAjax.call('".$this->method."','".$this->getAjaxParam(null,$val,'url')."',".$this->getAjaxParam(null,$val,'callBackJS').")";
                $arg='';
                if($this->useJSArg)
                    $arg=getArgFunction($val);
                $SCRIPT=<<<SCRIPTAJAX
function $val($arg){
                        $contain
}
SCRIPTAJAX;
                if($_VAR_FILE_=='ardeaBaseInit') {
                    $_initJs->addScript($SCRIPT);
                }else {
                    $script->addScript($SCRIPT);
                }
            }
            foreach($this->meth as  $key => $val) {
                if($_VAR_FILE_=='ardeaBaseInit') {
                    $_initJs->addScript("function x_".$key."(){");
                }else {
                    $script->addScript("function x_".$key."(){");
                }
                foreach( $val as  $valMethod) {
                    $arg='';
                    if($this->useJSArg)
                        $arg=getArgFunction($valMethod,$key);

                    $urlArg=$this->getAjaxParam(null,$key.".".$valMethod,'urlarg');
                    $urlArg=($urlArg=="")?"\"\"":$urlArg;
                    $contain="ardeaAjax.setDataFunc('".$key."','".$valMethod."',arguments,".$urlArg.")\n";
                    if($this->getAjaxParam(null,$key.".".$valMethod,'callBackJS')=="")
                        $contain.="ardeaAjax.call('".$this->method."','".$this->getAjaxParam(null,$key.".".$valMethod,'url')."','')";
                    else
                        $contain.="ardeaAjax.call('".$this->method."','".$this->getAjaxParam(null,$key.".".$valMethod,'url')."',".$this->getAjaxParam(null,$key.".".$valMethod,'callBackJS').")";
                    //$contain="ardeaAjax.call('".$this->method."','".$this->getAjaxParam(null,$key.".".$valMethod,'url')."',".$this->getAjaxParam(null,$key.".".$valMethod,'callBackJS').",'".$key."','".$valMethod."',arguments)";
                    $SCRIPT=<<<SCRIPTAJAX
    this.$valMethod=function($arg){
                            $contain
    }
SCRIPTAJAX;
                    if($_VAR_FILE_=='ardeaBaseInit') {
                        $_initJs->addScript($SCRIPT);
                    }else {
                        $script->addScript($SCRIPT);
                    }
                }
                if($_VAR_FILE_=='ardeaBaseInit') {
                    $_initJs->addScript("}");
                    $_initJs->addScript($key."=new x_".$key."();");
                }else {
                    $script->addScript("}");
                    $script->addScript($key."=new x_".$key."();");
                }
            }
        }
    }
    function isRegisteredFunction($funcName) {
        if(!in_array($funcName,$this->func)) {
            return false;
        }
        return true;
    }
    function isRegisteredMethod($className,$methodName) {
        if(!array_key_exists($className,$this->meth))
            return false;
        return true;
    }
    function setData($newdata) {
        $this->procAjax->setData($newdata);
    }

}
class processAjax {
    public $ver="version 1.0";
    public $name="Ardea Ajax";
    public $data="";
    public $errorCode=0;
    public $errorMessage=0;
    public $FOC=array();
    public $AUTO_FOC=true;
    private $defaultProcessFunction="ajaxProcess";
    private $defaultProcessFunctionDB="ajaxProcessDb";
    function processAjax() {
    }
    function addFOC($arrFunc) {
        $this->FOC=array_merge($this->FOC,$arrFunc);
    }
    function setDefaultNameFunction($newNameFunction) {
        $this->defaultProcessFunction=$newNameFunction;
    }
    function setDefaultNameFunctionDb($newNameFunction) {
        $this->defaultProcessFunctionDB=$newNameFunction;
    }
    function setData($newdata,$encode=false) {
        if ( $encode ) {
            encodeResponse( $newdata );
        }

        $this->data = $newdata;
    }

    function process($parent) {
        //$this->length=strlen($this->data);
        $this->processRequest($parent);
    }
    function processRequest($parent) {
        //die(var_dump(array_merge(array($parent->request),$parent->request->params)));
        switch($parent->request->type_send_data) {
            case "default":
                $this->processBasic($parent);
                break;
            case "func":
                $this->processFunc($parent);
                break;
            case "foc":
                $this->processFunc($parent,true);
                break;
            case "db":
                $this->processDb($parent);
                break;
            case "db_auto":
                $this->processDbAuto($parent);
                break;
        }
    }
    function processBasic($parent) {
        if(function_exists($this->defaultProcessFunction)) {
            //die(var_dump(call_user_func_array( $this->defaultProcessFunction,array($parent->request))));
            $parent->procAjax->setData(call_user_func_array( $this->defaultProcessFunction,array($parent->request)));
        }
        $this->addFOC($parent->getFOC());
    }
    function processDb($parent) {
        loadLib("lib.core.ardeaSecurity");
        $sc=new ardeaSecurity();
        if(isset($parent->request->form_data)) {
            foreach($parent->request->form_data as $value) {
                $value->value=$sc->queryDBFix($value->value);
                //die(var_dump($value));
            }
        }
        if(function_exists($this->defaultProcessFunctionDB))
            $parent->procAjax->setData(call_user_func_array( $this->defaultProcessFunctionDB,array($parent->request->form_data,$parent)));
        $this->addFOC($parent->getFOC());
    }
    function processDbAuto() {
        loadLib("lib.core.ardeaSecurity");
        loadLib("lib.core.db.ardeaDb");
        $db=new ardeaDB($this->typeDb,'');
        $sc=new ardeaSecurity();
        $rec=array();
        if(isset($parent->request->form_data)) {
            foreach($parent->request->form_data as $value) {
                if($value->id!=""&&$value->id!=null)
                    $rec[$value->id]=$sc->queryDBFix($value->value);
            }
        }
        if($this->tblName!=null) {
            $parent->procAjax->setData(_get_auto_update_sql($db,$this->opt,$rec,$this->wh));
            //$db->autoExecute($this->tblName,$this->opt,$rec,$this->wh);
        }
        $this->addFOC($parent->getFOC());
    }
    function processFunc($parent) {
        //die("XXX".var_dump($parent->request->params));
        if ( isset( $parent->request->cls ) ) {

            if($parent->isRegisteredMethod($parent->request->cls,$parent->request->mtd)) {
                if($parent->ajaxParamUseRequest) {
                    $parent->procAjax->setData(call_user_func_array( array( $parent->request->cls, $parent->request->mtd ), array_merge(array($parent->request),$parent->request->params) ),true);
                }else {
                    $parent->procAjax->setData(call_user_func_array( array( $parent->request->cls, $parent->request->mtd ), $parent->request->params ),true);
                }
            }
            $this->addFOC($parent->getFOC($parent->request->cls,$parent->request->mtd));
        }else if(isset( $parent->request->func )) {
            //die( $parent->request->mtd ." ". $parent->request->params);

            if($parent->isRegisteredFunction($parent->request->func)) {
                if($parent->ajaxParamUseRequest) {
                    $parent->procAjax->setData(call_user_func_array(  $parent->request->func , array_merge(array($parent->request),$parent->request->params) ),true);
                }else {
                    $parent->procAjax->setData(call_user_func_array(  $parent->request->func , $parent->request->params ),true);
                }
            }
            $this->addFOC($parent->getFOC(null,$parent->request->func));
            //$this->addFOC($parent->FOC);
        }else {
            if(isset( $parent->request->data )) {
                $parent->procAjax->setData($parent->request->data);
            }
        }

    }


}

//this script taken from AJASON 

function encodeResponse( &$response ) {
    if ( is_string( $response ) ) {
        $response = utf8_encode( $response );
    }
    else if ( is_array( $response ) ) {
        foreach ( $response as &$item ) {
            encodeResponse( $item );
        }
    }
    else if ( is_object( $response ) ) {
        foreach ( get_object_vars( $response ) as $key => $item ) {
            encodeResponse( $item );
            eval( "\$response->$key = \$item;" );
        }
    }
}


?>