<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    :
 * Date    :
 * Used for:
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
loadLib("lib.core.math.int");
class menu extends objectObject {
    private $tmp_prop=null;
    function menu($id) {
        global $ardeaCore;
        $this->initOnly();
        $this->property->property["ardea_menu_property"]=array();
        $this->tmp_prop=& $this->property->property["ardea_menu_property"];
        $this->setNoUsedBuild();
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaProgresBar.js'));
        $this->tmp_prop["items"]=array();
        $this->tmp_prop["menu"]=array();
        $this->tmp_prop["rootMenuWidth"]="50px";
        $this->name=fixVarNameJS($id);
        $this->addJsFile('ardeaMenu.js');
        $this->addJsFile('ardeaTimer.js');
        $this->addJsFile('ardeaTableDynamic.js');
    }
    function addMenu($menuId,$caption) {
        $menuId=fixVarNameJS($menuId);
        $this->tmp_prop["menu"][$menuId]=array();
        $this->tmp_prop["menu"][$menuId]["id"]=$menuId;
        $this->tmp_prop["menu"][$menuId]["caption"]=$caption;
        $this->tmp_prop["menu"][$menuId]["items"]=array();
        //$this->tmp_prop["menu"][$menuId]["subMenu"]=array();
    }
    function addItem($parentId,$itemId,$caption) {
        $option=argToOption(func_get_args(),"onclick,icon_a,icon_b");
        $onclick=getOption($option,"onclick",3);
        $icon_a=getOption($option,"icon_a",4);
        $icon_b=getOption($option,"icon_b",5);
        $parentId=fixVarNameJS($parentId);
        $itemId=fixVarNameJS($itemId);
        if(array_key_exists($itemId,$this->tmp_prop["items"]))
            return null;
        $this->tmp_prop["items"][$itemId]=array();
        $this->tmp_prop["items"][$itemId]["id"]=$itemId;
        $this->tmp_prop["items"][$itemId]["caption"]=$caption;
        $this->tmp_prop["items"][$itemId]["items"]=array();
        if($onclick!="")
            $this->tmp_prop["items"][$itemId]["onclick"]=$onclick;
        else
            $this->tmp_prop["items"][$itemId]["onclick"]=null;
        if($icon_a!="")
            $this->tmp_prop["items"][$itemId]["icon_a"]=$icon_a;
        else
            $this->tmp_prop["items"][$itemId]["icon_a"]=null;
        if($icon_b!="")
            $this->tmp_prop["items"][$itemId]["icon_b"]=$icon_b;
        else
            $this->tmp_prop["items"][$itemId]["icon_b"]=null;

        if(array_key_exists($parentId,$this->tmp_prop["menu"])) {
            $this->tmp_prop["menu"][$parentId]["items"][$itemId]=$this->tmp_prop["items"][$itemId];
        }elseif(array_key_exists($parentId,$this->tmp_prop["items"])) {
            $this->tmp_prop["items"][$parentId]["items"][$itemId]=$this->tmp_prop["items"][$itemId];
        }

    }
    function setRootMenuWidth($newWidth) {
        $this->tmp_prop["rootMenuWidth"]=$newWidth;
    }
    private function recur_items( $arrItem,$parent) {
        global $_funcLoad;
        if($this->useAjax) {
            $_func=$this->parent_var_for_child["script_object"];
        }else {
            $_func=$_funcLoad;
        }
        //die(print_r($arrItem).print_r($this->tmp_prop["items"]));
        foreach($arrItem as $key_items => $value_items) {
            if($value_items["caption"]=="separator"||$value_items["caption"]=="-") {
                $_func->addScript($this->name."_".$parent["id"].".addItem('".$key_items."',new menuSeparator());") ;
            }else {
                $tmpArgStr="'".$value_items["caption"]."'";
                if($value_items["onclick"]!=null)
                    $tmpArgStr.=",'onclick=".$value_items["onclick"]."'";
                if($value_items["icon_a"]!=null)
                    $tmpArgStr.=",'icon_a=".$value_items["icon_a"]."'";
                if($value_items["icon_b"]!=null)
                    $tmpArgStr.=",'icon_b=".$value_items["icon_b"]."'";
                $_func->addScript($this->name."_".$parent["id"].".addItem('".$key_items."',new menuItem(".$tmpArgStr."));") ;
            }
            if(count($this->tmp_prop["items"][$value_items["id"]]["items"])>0) {
                $_func->addScript($this->name."_".$key_items."=".$this->name."_".$parent["id"].".addSubMenu('".$key_items."','".$key_items."');") ;
                $this->recur_items($this->tmp_prop["items"][$value_items["id"]]["items"],$value_items);
            }
        }

    }
    protected function buildJs() {
        global $_VAR_FILE_;
        global $_funcLoad;
        if($this->useAjax) {
            // die(var_dump($this->parent_var_for_child));
            if($_VAR_FILE_==$this->parent_var_for_child["fl_js_name"]) {
                $_script=&$this->parent_var_for_child["script_object"];
                $_script->addScript("var ".$this->name." = new ardeaMenu('".$this->name."');") ;
                $_script->addScript($this->name.".rootMenuWidth=\"".$this->tmp_prop["rootMenuWidth"]."\"");
                //              die(print_r($this->tmp_prop["menu"]));
                foreach($this->tmp_prop["menu"] as $key => $value) {
                    $_script->addScript($this->name."_".$key."=".$this->name.".addMenu('".$key."','".$value["caption"]."');") ;
                    if(count($value["items"])>0) {
                        $this->recur_items($value["items"],$value);
                    }
                }
                if(!$this->JsScriptToTmp) {
                    $_script->addScript($this->name.".finished();") ;
                }else {
                    $_script->addScriptTmp($this->name.".setParentHome(".$this->parent_var_for_child['body_menu'].",null,ardeaWindow.getWindow(\"".$this->parent_var_for_child['window_name']."\"));");
                    $_script->addScriptTmp($this->name.".finished();") ;
                }
            }
        }else {
            if($_VAR_FILE_=='ardeaBaseInit') {
                $_funcLoad->addScript("var ".$this->name." = new ardeaMenu('".$this->name."');") ;
                $_funcLoad->addScript($this->name.".rootMenuWidth=\"".$this->tmp_prop["rootMenuWidth"]."\"");
                //              die(print_r($this->tmp_prop["menu"]));
                foreach($this->tmp_prop["menu"] as $key => $value) {
                    $_funcLoad->addScript($this->name."_".$key."=".$this->name.".addMenu('".$key."','".$value["caption"]."');") ;
                    if(count($value["items"])>0) {
                        $this->recur_items($value["items"],$value);
                    }
                }
                if(!$this->JsScriptToTmp) {
                    $_funcLoad->addScript($this->name.".finished();") ;
                }else {
                    $_funcLoad->addScriptTmp($this->name.".setParentHome(".$this->parent_var_for_child['body_menu'].",null,ardeaWindow.getWindow(\"".$this->parent_var_for_child['window_name']."\"));");
                    $_funcLoad->addScriptTmp($this->name.".finished();") ;
                }

            }
        }
    }
}
class menuSide extends objectObject {
    private $menu=array();
    private $styleMenu="default";
    function menuSide($width="200px",$height="32px") {
        $this->initOnly();
        $this->property->property["ardea_menu_property"]=array();
        $this->tmp_prop=& $this->property->property["ardea_menu_property"];
        $this->tmp_prop["width"]=$width;
        $this->tmp_prop["height"]=$height;
        $this->tmp_prop["height_a_minus"]=0;
        $this->setNoBuildProperty();
    }
    function addMenu($menuName,$value="",$url="",$current=false) {
        $this->menu[$menuName]=array();
        $this->menu[$menuName]["url"]=$url;
        $this->menu[$menuName]["current"]=$current;
        $this->menu[$menuName]["value"]=($value=="")?$menuName:$value;
    }
    function setDataMenu($dataArray) {
        if(is_array($dataArray)) {
            foreach($dataArray as $key=>$value) {
                $url=array_key_exists("url",$value)?$value["url"]:"";
                $current=array_key_exists("current",$value)?$value["current"]:false;
                $value=array_key_exists("value",$value)?$value["value"]:$key;
                $this->addMenu($key,$value,$url,$current);
            }
        }
    }
    function setWidth($newWidth) {
        $this->tmp_prop["width"]=$newWidth;
    }
    function setHeight($newHeight) {
        $this->tmp_prop["height"]=$newHeight;
    }
    function setStyleMenu($newStyle) {

        $this->styleMenu=$newStyle;
        //die(var_dump($this->styleMenu));
    }
    function loadSettingCSS() {
        switch($this->styleMenu) {
            case "default":
                $curWidth="200px";
                $curHeight="32px";
                $this->tmp_prop["height_a_minus"]=8;
                break;
            case "blue":
                $curWidth="200px";
                $curHeight="32px";
                $this->tmp_prop["height_a_minus"]=8;
                break;
        }
        $this->tmp_prop["width"]=($this->tmp_prop["width"]!=$curWidth)?$this->tmp_prop["width"]:$curWidth;
        $this->tmp_prop["height"]=($this->tmp_prop["height"]!=$curHeight)?$this->tmp_prop["height"]:$curHeight;
    }
    function buildObject() {
        global $ardeaCore;
        $this->loadSettingCSS();
        $ardeaCore->addCssPath($ardeaCore->getURLCSS('sidemenu/'.$this->styleMenu.'.css'));
        $strHTML="<div id=\"menu\" class=\"menu_".$this->styleMenu."_side\" style=\"width:".$this->tmp_prop["width"].";\">\n";
        $strHTML.="  <ul class=\"ul_menu_".$this->styleMenu."_side\">\n";
        $height_a_tag=getInt($this->tmp_prop["height"])-$this->tmp_prop["height_a_minus"];
        foreach($this->menu as $key => $value) {
            if($value["current"]) {
                //$strHTML.="   <li style=\"height:".$this->tmp_prop["height"].";\"><a  style=\"height:".$this->tmp_prop["height"].";\" id=\"current\" href=\"".$value["url"]."\">".$value["value"]."</a></li>\n";
                $strHTML.="   <li style=\"height:".$this->tmp_prop["height"].";\"><a  style=\"height:".$height_a_tag."px;\" id=\"current\" href=\"".$value["url"]."\">".$value["value"]."</a></li>\n";
            }else {
                //$strHTML.="   <li style=\"height:".$this->tmp_prop["height"].";\"><a  style=\"height:".$this->tmp_prop["height"].";\" id=\"".$key."\" href=\"".$value["url"]."\">".$value["value"]."</a></li>\n";
                $strHTML.="   <li style=\"height:".$this->tmp_prop["height"].";\"><a   style=\"height:".$height_a_tag."px;\" id=\"".$key."\" href=\"".$value["url"]."\">".$value["value"]."</a></li>\n";
            }
        }
        $strHTML.=" </ul>\n";
        $strHTML.="</div>\n";
        $this->strHTML=$strHTML;
    }
}
?>
