<?php
/*======================================================
 * %%%%%%%%%%%%%PHPArdea CORE 2.0%%%%%%%%%%%%%%%%%%%%%%%
 * =====================================================
 * Author  : Maulana Al Matien.
 * Email   : ardea.core.php@gmail.com
 * Name    : ardeaRecNavigator.php
 * Date    :
 * Used for: Basic library for Variable in ArdeaCore
 * ======================================================
 * Copyright Ardea Workshop. http://ardea-workshop.co.cc/ardeaCore.php
 * You allowed to use this component or parts of it under LGPLv3 terms
 * To use it on other terms or get Professional edition of the component
 * please contact us at ardea.core.php@gmail.com
*/
/**
 * @version		2.0
 * @package		object
 * @subpackage	core
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class recordNavigator extends objectObject {
    private $localProp;
    private $navSelector=array();
    function recordNavigator($name='recnav') {
        $this->name=fixVarNameJS($name);
        $this->initOnly();
        $this->setNoBuildProperty();
        $this->localProp=$this->property->property["ardea_rec_nav_property"]=array();
        $this->localProp['sql']="";
        $this->localProp['sqlResult']="";
        $this->localProp['limit']=-1;
        $this->localProp['rs']="";
        $this->localProp['maxCell']=3;
        $this->localProp['recPerPage']=10;
        $this->localProp['curMaxRec']=0;

        //$this->localProp['5']
    }
    function setRecordPerPage($recordCount) {
        $this->localProp['recPerPage']=$recordCount;
    }
    function setMaxPage($maxPageInt) {
        $this->localProp['maxCell']=$maxPageInt;
    }
    function setRs($rs) {
        $this->localProp['rs']=$rs;
    }
    function getRs() {
        return $this->localProp['rs'];
    }
    function getSQL() {
        return $this->localProp['sql'];
    }
    function setSQL($sqlString,$force=false) {
        if($this->localProp['sql']==""||$force) {
            if(strpos(strtolower($sqlString),"limit")>-1) {
                $sqlString=substr($sqlString,0,strpos(strtolower($sqlString),"limit"));
            }
            $this->localProp['sql']=$sqlString;
        }
    }
    function buildObject() {
        global $ardeaCore;
        $ardeaCore->addJsPath($ardeaCore->getURLJS('ardeaRecordNav.js'));
        if($this->localProp['sql']=="")die("ERROR SQL QUERY IS EMPTY");
        $tmpRsCount=$ardeaCore->executeSQL($this->localProp['sql'],2);
        if(!$tmpRsCount) {
            $this->localProp['rs']=false;
            return;
        }

        $this->localProp['curMaxRec']=$tmpRsCount->recordCount();
        $pos=getPostVar("pos_nav");
        $pos=($pos=="")?getGetVar("pos_nav"):$pos;
        $pos=($pos=="")?1:$pos;
        $opt=getPostVar("opt_nav");
        $opt=($opt=="")?getGetVar("opt_nav"):$opt;
        $opt=($opt=="")?0:$opt;
        $this->createNavSelector($pos,$opt);
        $this->createOwnNavigate();
    }

    function createNavSelector($pos,$opt) {
//$opt="1:3:next";
//$pos=30;  
//echo $pos.":".$opt."AAAA;";      
        $this->navSelector["next_button_show"]=false;
        $this->navSelector["prev_button_show"]=false;
        $this->navSelector["show_first"]=false;
        $this->navSelector["show_end"]=false;
        $maxPage=floor($this->localProp['curMaxRec']/$this->localProp['recPerPage']);
        $maxPage=($this->localProp['curMaxRec']%$this->localProp['recPerPage']>0)?$maxPage+1:$maxPage;

        if($opt==0) {
            if($maxPage<$this->localProp['maxCell'])$this->localProp['maxCell']=$maxPage;
            $min=1;
            $max=$this->localProp['maxCell'];
            $optNav='first';
            if($maxPage>$this->localProp['maxCell'])$this->navSelector["next_button_show"]=true;
        }else {
            $opt=explode(":",$opt);
            if($pos==1) {
                $min=1;
                $max=$this->localProp['maxCell'];
            }else if($pos==$this->localProp['curMaxRec']) {

                $min=$maxPage-$this->localProp['maxCell']+1;
                $max=$maxPage;
                //die("MASUK".$min.$max);
            }else {
                $min=$opt[0];
                $max=$opt[1];
            }
            $optNav=$opt[2];
            if($optNav=='next') {
                if(($max+1)>$maxPage) {

                }else {
                    $min++;
                    $max++;
                    $max=($max>$maxPage)?$maxPage:$max;
                    $this->navSelector["next_button_show"]=true;
                }
                $pos=($pos<($min*$this->localProp['recPerPage']))?$min*$this->localProp['recPerPage']:$pos;
            }else if($optNav=='back') {
                if(($min-1)<0) {

                }else {
                    $min--;
                    $max--;
                }
//               if(($min-1)!=0)$this->navSelector["prev_button_show"]=true;
                //echo "||".$min." ".$max." ".$pos." ".($max*$this->localProp['recPerPage'])."||";
                $pos=($pos>($max*$this->localProp['recPerPage']))?$max*$this->localProp['recPerPage']:$pos;
            }
            if($min>1)$this->navSelector["prev_button_show"]=true;
            if($min>1)$this->navSelector["show_first"]=true;
            if($max<$maxPage)$this->navSelector["next_button_show"]=true;
            if($max<$maxPage)$this->navSelector["show_end"]=true;


            //die($pos."A".$min);
            //echo $optNav.($min-1).var_dump($this->navSelector["prev_button_show"]).";";
        }


        for($i=0;$i<$this->localProp['maxCell'];$i++) {
            if($i+$min<=$maxPage) {
                $arrTmp=array();
                //echo $pos." : ".($min+$i)." : ".(($min+$i-1)*$this->localProp['recPerPage'])." : ".(($min+$i)*$this->localProp['recPerPage']).",";
                $arrTmp["pos"]=($min+$i)*$this->localProp['recPerPage'];
                $arrTmp["page"]=($min+$i);

                if($pos>=((($min+$i-1)*$this->localProp['recPerPage'])+1)&&$pos<=($min+$i)*$this->localProp['recPerPage']) {
                    $arrTmp["curPage"]=true;
                    $this->navSelector["current_page"]=$min+$i;
                }else {
                    $arrTmp["curPage"]=false;
                }
                $this->navSelector[$i]=$arrTmp;
                unset($arrTmp);
            }
        }

        $this->navSelector["opt_pos"]=$pos;

        $this->navSelector["opt_page"]=$min.":".$max;
        $this->navSelector["limit_page"]=$this->localProp['maxCell'];
        $this->navSelector["page_count"]=$maxPage;
        $this->navSelector["record_count"]=$this->localProp['curMaxRec'];
        $this->navSelector["limit_sql"]=" LIMIT ".(($this->navSelector["current_page"]-1)*$this->localProp['recPerPage']).",".(($this->navSelector["current_page"])*$this->localProp['recPerPage']);
        //die(var_dump($this->navSelector).$pos);
        //var_dump($this->navSelector).$pos;
    }
    function getSQLLIMIT() {
        return $this->navSelector["limit_sql"];
    }
    function getHTMLTag($opt,$arrOpt=null) {
        global $ardeaCore;
        global $ardeaVar;
        switch(strtolower($opt)) {
            case "show_first":
                if($this->navSelector["show_first"])return '<a href="javascript:void(0)" onclick="ardeaNavigator.gotoPage(1)">1--</a>';
                break;
            case "show_end":
                if($this->navSelector["show_end"])return '<a href="javascript:void(0)" onclick="ardeaNavigator.gotoPage('.$this->navSelector["record_count"].')">--'.$this->navSelector["page_count"].'</a>';
                break;
            case "next":
                return '<a href="javascript:void(0)" onclick="ardeaNavigator.gotoNext()">next</a>';
                break;
            case "back":
                return '<a href="javascript:void(0)" onclick="ardeaNavigator.gotoBack()">prev</a>';



                break;
            case "page":
                if($arrOpt["curPage"]) {
                    return '<a href="javascript:void(0)" onclick="ardeaNavigator.gotoPage('.$arrOpt["pos"].')"><b>'.$arrOpt["page"].'</b></a>';
                }else {
                    return '<a href="javascript:void(0)" onclick="ardeaNavigator.gotoPage('.$arrOpt["pos"].')">'.$arrOpt["page"].'</a>';
                }
                break;
            case "js_next":
                return '"gotoNext()"';
                break;
            case "js_back":
                return '"gotoBack()"';
                break;
            case "js_page":
                return '"gotoPage('.$arrOpt["page"].')"';
                break;
            case "textPage":
                return "Page ".$this->navSelector["current_page"]." of ".$this->navSelector["page_count"];
                break;
            case "form":
                $tmpStr="<!---Begin Ardea Record Navigator--->\n"  ;
                $tmpStr.="<form action='".$ardeaCore->getURL()."?".addURLGET()."' method='post' id='".$this->name."'>\n"  ;
                $tmpStr.=$arrOpt;
                $tmpStr.="<input type='hidden' value='".$this->navSelector["opt_pos"]."' name='pos_nav' id='pos_nav'/>\n" ;
                $tmpStr.="<input type='hidden' value='".$this->navSelector["opt_page"]."' name='opt_nav' id='opt_nav'/>\n" ;
                $tmpStr.="</form>\n"  ;
                $tmpStr.="<!---END Ardea Record Navigator--->\n"  ;
                return $tmpStr;
                break;

        }
    }
    function createOwnNavigate() {
        $strResult="<table border=0><tr>\n";
        if($this->navSelector["prev_button_show"])$strResult.="<td>".$this->getHTMLTag("back")."</td>\n";
        $strResult.="<td>".$this->getHTMLTag("show_first")."</td>";
        for($i=0;$i<$this->navSelector["limit_page"];$i++) {
            $strResult.="<td>".$this->getHTMLTag("page",$this->navSelector[$i])."</td>\n";
        }
        $strResult.="<td>".$this->getHTMLTag("show_end")."</td>";
        if($this->navSelector["next_button_show"])$strResult.="<td>".$this->getHTMLTag("next")."</td>\n";
        $strResult.="</tr></table>\n";
        $this->strHTML=$this->getHTMLTag('form',$strResult);
    }
}

?>
