<?php
/**
 * PHP Template.
 */
  /**
 * @version		2.0
 * @package		object.plugin
 * @subpackage	graph
 * @author	Maulana al matien
 * @copyright Ardea-Workshop/Maulana Al Matien (2008-2009). All rights reserved.
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public License (LGPLv3)
 */
class ardeaGraph extends objectObject{
      private $child;
      private $url='';
      public $width=100;
      public $height=50;
      public $name='';
      public $type='';
      private $chartFile="";
      public function ardeaGraph($name=null,$type='fusion_bar2d'){

      /*
      $newDBProperty='bgColor,bgAlpha,bgSWF,canvasBgColor,canvasBgAlpha,canvasBaseColor,canvasBaseDepth,canvasBaseDepth,canvasBgDepth,showPercentageInLabel,showCanvasBg,showCanvasBase,canvasBorderColor,canvasBorderThickness,caption,subCaption,xAxisName,yAxisName,yAxisMinValue,yAxisMaxValue,shownames,showValues,showLimits,rotateNames,animation,showColumnShadow,baseFont';
      $newDBProperty.=',baseFontSize,baseFontColor,outCnvBaseFont,outCnvBaseFontSze,outCnvBaseFontColor,numberPrefix,numberSuffix,formatNumber,formatNumberScale,decimalSeparator,thousandSeparator,decimalPrecision,divLineDecimalPrecision,limitsDecimalPrecision,zeroPlaneThickness,zeroPlaneColor,zeroPlaneAlpha,numdivlines,divlinecolor,divLineThickness';
      $newDBProperty.=',divLineAlpha,showDivLineValue,showAlternateHGridColor,alternateHGridColor,alternateHGridAlpha,numVDivLines,VDivlinecolor,VDivLineThickness,VDivLineAlpha,showAlternateVGridColor,alternateVGridColor,alternateVGridAlpha,showhovercap,hoverCapBgColor,hoverCapBorderColor,hoverCapSepChar,chartLeftMargin,chartRightMargin,chartTopMargin,chartBottomMargin,pieRadius,pieSliceDepth,pieYScale,pieBorderThickness';
      $newDBProperty.=',pieBorderAlpha,pieFillAlpha,slicingDistance,nameTBDistance,showShadow,shadowColor,shadowAlpha,shadowXShift,shadowYShift,width,height,Data,type,PYAxisName,SYAxisName,anchorSides,anchorRadius,anchorBorderColor,seriesName,color,areaAlpha,showAreaborder,areaBorderThickness,areaBorderColor,startValue,endValue,displayValue,thickness,alpha,parentYAxis,fileXML,showPercentageValues';
      $this->setDBProperty('datagraph',$newDBProperty);
      $this->setActivePropertyParent('datagraph');
       *
       */
      $this->initOnly() ;
      $this->property->property["ardea_graph"]=array();
      $this->tmp_Prop=& $this->property->property["ardea_graph"];
      $this->setNoBuildProperty();
      $this->setDataType($type);
      if($name!=null)
        $this->name=$name;
      }
      function setDataType($type){
          $this->type=$type;
          $typeA=$type;
          if(strpos(strtolower($type),"fusion")>-1)
            $typeA='fusion';
          
          switch($typeA){
              case 'fusion':
              $typeArr=split("_",$type);
              $typeArr=$this->getSettingFusion($typeArr[1]);
              if($typeArr["type_data"]=="simple"){
                loadLib("object.plugin.graph.ardeaDataSimple");
                $this->data=new dataSimple();
              }else{
                loadLib("object.plugin.graph.ardeaDataSeries");
                $this->data=new dataSeries();
              }
              $this->chartFile=$typeArr["filename"];
              $this->type=$typeArr["type_data"];
              break;
              case 'jpgraph':
              $this->data=array();
              break;
              case 'ofc':
              $this->data=array();
              break;
          }
      }
      function addAttribute($key,$value){
          $this->tmp_Prop[$key]=$value;
      }
      function setCategory($categoryItemArray){
          //die(var_dump($this->type));
          if($this->type!='series'){
              return;
          }
           $this->data->setCategory($categoryItemArray);
      }
      function addData($data){
          if($this->type=='series'){
           $arg=func_get_args();
           if(count($arg)==1)
              return;
          $this->data->addData($arg[0],$arg[1]);
          }else{
            $this->data->addData($data);
          }
      }
      function setName($newName){
        $this->name=$newName;
      }
      function getName(){
          return $this->name;
      }
      function setURLXML($newURL){
          $this->url=$newURL;
      }
      function setWidth($newWidth){
          $this->width=$newWidth;
      }
      function setHeight($newHeight){
          $this->height=$newHeight;
      }
      function getWidth(){
          return $this->width;
      }
      function getHeight(){
          return $this->height;
      }
      function addChild($newChild){
          $this->child=$newChild;
      }
    function getSettingFusion($type){
    global $ardeaCore;
    $result=array();
    $path_graph_file=$ardeaCore->getURLJS("graph/FusionCharts/",true);
    $found=false;
    switch(strtolower($type)){
    case "bar2d":     //simple
    $result["filename"]=$path_graph_file."FCF_Bar2D.swf";
    $result["type_data"]="simple";
    $found=true;
    break;
    case "pie2d":     //simple
    $result["filename"]=$path_graph_file."FCF_Pie2D.swf";
    $result["type_data"]="simple";
    $found=true;
    break;
    case "pie3d":     //simple
    $result["filename"]=$path_graph_file."FCF_Pie3D.swf";
    $result["type_data"]="simple";
    $found=true;
    break;
    case "col3d":     //simple
    $result["filename"]=$path_graph_file."FCF_Column3D.swf";
    $result["type_data"]="simple";
    $found=true;
    break;
    case "col2d":     //simple
    $result["filename"]=$path_graph_file."FCF_Column2D.swf";
    $result["type_data"]="simple";
    $found=true;
    break;
    case "donut" :    //simple
    $result["filename"]=$path_graph_file."FCF_Doughnut2D.swf";
    $result["type_data"]="simple";
    $found=true;
    break;
    case "stacked2d":
    $result["filename"]=$path_graph_file."FCF_StackedColumn2D.swf";
    $result["type_data"]="series";
    $found=true;
    break;
    case "stacked3d":
    $result["filename"]=$path_graph_file."FCF_StackedColumn3D.swf" ;
    $result["type_data"]="series";
    $found=true;
    break;
    case "stackedbar2d":
    $result["filename"]=$path_graph_file."FCF_StackedBar2D.swf" ;
    $result["type_data"]="series";
    $found=true;
    break;
    case "multi" :
    $result["filename"]=$path_graph_file."FCF_MSColumn3DLineDY.swf" ;
    $result["type_data"]="series";
    $found=true;
    break;
    case "msarea2d" :
    $result["filename"]=$path_graph_file."FCF_MSArea2D.swf" ;
    $result["type_data"]="series";
    $found=true;
    break;
    case "msline" :
    $result["filename"]=$path_graph_file."FCF_MSLine.swf" ;
    $result["type_data"]="series";
    $found=true;
    break;
    }
    if(!$found){
        $result["filename"]=$path_graph_file."FCF_Bar2D.swf";
        $result["type_data"]="simple";
    }
    return $result;
    }

      function buildObject(){
          global $_VAR_LOAD_;
          global $ardeaCore;
          switch($this->type){
              case 'simple':
              case 'series':
                 $ardeaCore->addJsPath($ardeaCore->getURLJS('graph/FusionCharts/FusionCharts.js',true));
                 $this->strHTML=html('div','id="'.$this->name.'_div" style="width:'.$this->width.";height:".$this->width.';"');
              break;
              case 'ofc':
              break;
              case  'jpgraph':
              break;
          }
      }
      function buildJs(){
          global $_VAR_FILE_;
          global $_funcLoad;
          if($_VAR_FILE_=='ardeaBaseInit'){
              if($this->url==""){
                 $this->url=$this->getURLForXMLFile($this->name."_data",false,"xml_1");
              }
              $_funcLoad->addScript("var ".$this->name."_chart = new FusionCharts('".$this->chartFile."','ChartId', '".$this->width."', '".$this->height."');") ;
              $_funcLoad->addScript($this->name."_chart.setDataURL('".$this->url."');");
              $_funcLoad->addScript($this->name."_chart.render('".$this->name."_div');");
          }
      }
      function buildXML(){
         
         if($this->url==""){
                 $this->data->build();
                 $data=$this->data->getData();
                 //var_dump($data);
                 foreach($this->tmp_Prop as $key => $value){
                    $data->addAttribute($key,$value);
                 }
                 //generateNode2Array($data,$dat);
                 //print_r($dat);
                 $dom=new ardeaDOM();
                 $dom->toXML($data);
                 //$dom->write('xml+header',$this->name.'_xml','text/xml',"inline");
                 $dom->write();
        }
       }
          
         
}

?>
